

   MEMBER('H5Signature.clw')                               ! This is a MEMBER module


   INCLUDE('ABLPROPR.INC'),ONCE
   INCLUDE('ABLWINR.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('WBFRAME.INC'),ONCE
   INCLUDE('ablwman.inc'),ONCE

                     MAP
                       INCLUDE('H5SIGNATURE001.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Frame
!!! </summary>
Main PROCEDURE 

AppFrame             APPLICATION('H5 Signature Demo by Jeffrey Kuijt'),AT(,,505,318),FONT('Microsoft Sans Serif', |
  8,,FONT:regular),RESIZE,CENTER,ICON('WAFRAME.ICO'),MASK,MAX,STATUS(-1,80,120,45),SYSTEM,IMM
                       MENUBAR,USE(?Menubar)
                         ITEM('Enter signature'),USE(?Signature)
                       END
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()
Kill                   PROCEDURE(),DERIVED
                     END

WebFrame             CLASS(WbFrameClass)
TakeEvent              PROCEDURE(),SIGNED,PROC,DERIVED
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetProperty            PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0),*IValue,DERIVED
GetSkeletonAttr        PROCEDURE(SIGNED whichAttr),STRING,DERIVED
Init                   PROCEDURE()
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
Menu::Menubar ROUTINE                                      ! Code for menu items on ?Menubar
  CASE ACCEPTED()
  OF ?Signature
    WindowSignature()
  END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  WebFrame.FrameWindow &= AppFrame
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (Main)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
      AppFrame{PROP:TabBarVisible}  = False
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  SetWebActiveFrame()
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::Menubar                                     ! Process menu items on ?Menubar menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


WebWindowProperty.GetProperty PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0)

ReturnValue          &IValue

  CODE
  IF (name = 'InFrame')
     RETURN CreateBoolValue(true)
  END
  ReturnValue &= PARENT.GetProperty(name,idx1,idx2)
  RETURN ReturnValue


WebWindowProperty.GetSkeletonAttr PROCEDURE(SIGNED whichAttr)

ReturnValue          ANY

  CODE
  IF whichAttr = SkeletonAttr:RuntimeLayout
     RETURN 'off'
  END
  ReturnValue = PARENT.GetSkeletonAttr(whichAttr)
  CASE whichAttr
  END
  RETURN ReturnValue


WebWindowProperty.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetTimeOut(600 - 60) !Set to keep the client app Alive


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  WebWindowProperty.Init()
  WebWindowProperty.SetSubmitOnCancel(TRUE)
  SELF.AddControl(WebWindowProperty)
  SetWebActiveFrame(WebFrame)


WebWindow.Kill PROCEDURE

  CODE
  WebWindowProperty.Kill()
  PARENT.Kill


WebFrame.TakeEvent PROCEDURE

ReturnValue          SIGNED,AUTO

FirstIteration       SIGNED(1)
  CODE
  ReturnValue = PARENT.TakeEvent()
  LOOP
    RETURN REPLY:NONE
  END
  ReturnValue = REPLY:BREAK
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!! Enter signature
!!! </summary>
WindowSignature PROCEDURE 

!LOC:SignatureData - make it big enough, but 200K will do the job
LOC:SignatureData    STRING(200000)                        ! 
QuickWindow          WINDOW('Generate signature'),AT(,,273,113),FONT('Microsoft Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  CENTER,GRAY,IMM,SYSTEM
                       GROUP,AT(2,2,269,107),USE(?GROUP1),BOXED
                         PROMPT('Your signature:'),AT(9,8),USE(?LOC:SignatureData:Prompt)
                         TEXT,AT(9,22,253,61),USE(LOC:SignatureData),VSCROLL,BOXED
                         BUTTON('Generate'),AT(9,87,49,14),USE(?Ok),DEFAULT
                         BUTTON('Try again'),AT(220,87),USE(?BtnClearSignature)
                       END
                     END
Web:CurFrame         &WbFrameClass

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
! ----- str --------------------------------------------------------------------------
str                  Class(StringTheory)
                     End  ! str
! ----- end str -----------------------------------------------------------------------
WebWindowManager     WbWindowManagerClass
WebWindow            CLASS(WbWindowClass)
Init                   PROCEDURE()
Kill                   PROCEDURE(),DERIVED
                     END

Web:LOC:SignatureData:Prompt CLASS(WbControlHtmlProperties) ! Web Control Manager for ?LOC:SignatureData:Prompt
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED
                     END

Web:LOC:SignatureData CLASS(WbControlHtmlProperties)       ! Web Control Manager for ?LOC:SignatureData
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED
                     END

Web:Ok               CLASS(WbControlHtmlProperties)        ! Web Control Manager for ?Ok
Init                   PROCEDURE(SIGNED Feq,SIGNED Container)
                     END

Web:BtnClearSignature CLASS(WbControlHtmlProperties)       ! Web Control Manager for ?BtnClearSignature
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED
GetProperty            PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0),*IValue,DERIVED
Init                   PROCEDURE(SIGNED Feq,SIGNED Container)
                     END

WebWindowProperty    CLASS(WbWindowHtmlProperties)
GetEmbedText           PROCEDURE(ASTRING embed),STRING,DERIVED
GetProperty            PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0),*IValue,DERIVED
GetSkeletonAttr        PROCEDURE(SIGNED whichAttr),STRING,DERIVED
Init                   PROCEDURE()
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('WindowSignature')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?LOC:SignatureData:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Ok,RequestCancelled)                    ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Ok,RequestCompleted)                    ! Add the close control to the window manger
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF (WebServer.IsEnabled())
    WebWindow.Init()
    WebWindowManager.Init(WebServer, WebWindow.IPageCreator, WebWindow.IWebResponseProcessor, 0{PROP:text} & ' (WindowSignature)')
    SELF.AddItem(WebWindow.WindowComponent)
    SELF.AddItem(WebWindowManager.WindowComponent)
  END
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF (WebServer.IsEnabled())
    POST(EVENT:NewPage)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Ok
      ThisWindow.Update()
      IF CLIP(LOC:SignatureData) <> ''
        TempID# = CLOCK()
        !Let StringTheory decode the base64 code and save it as a png file.
        str.Start()
        str.SetValue(LOC:SignatureData)
        str.SetValue(str.After('data:image/png;base64,'))
        str.Base64Decode()
        str.SaveFile(CLIP(WebFilesManager.GetInstanceDirectory(1)) & '\' & CLIP(TempID#) & '_signature.png')
        MESSAGE('The signature has been saved in the Public Instance folder.','Signature has been saved')
        !
        !Clarion reports can't handle 32-bits RGBA png images with transparency, because then you will get an ugly black backgroud.
        !The solution is to make use of a free tool called ImageMagick:
        !https://www.imagemagick.org/script/download.php
        !ImageMagick-7.0.5-0-portable-Q16-x64.zip
        !With this tool you can for example replace the transparent background with a white background, see:
        !http://stackoverflow.com/questions/2322750/replace-transparency-in-png-images-with-white-background
        !Example:
        !convert image.png -background white -alpha remove white.png
        !The result is a 24-bits png image with a white background en that works perfectly in Clarion reports.
        !  RUN('convert.exe "' & CLIP(WebFilesManager.GetInstanceDirectory(1)) & '\' & CLIP(TempID#) & '_signature.png" -background white -alpha remove "' & CLIP(WebFilesManager.GetInstanceDirectory(1)) & '\' & CLIP(TempID#) & '_signature_24bit.png"',1)
      END      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Web:LOC:SignatureData:Prompt.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedBeforeControl
    Target.Writeln('<<label class="sstring mark lead main-header">')
    Target.Writeln('Generate signature')
    Target.Writeln('<</label>')
    !
    Target.Writeln('<<label class="sstring mark sub-header">')
    Target.Writeln('H5 Demo by Jeffrey Kuijt')
    Target.Writeln('<</label>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


Web:LOC:SignatureData.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedAfterControl
      Target.Writeln('<<div id="signatureparent">')
      Target.Writeln('<<div id="signature"><</div>')
      Target.Writeln('<</div>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


Web:Ok.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SetExtraProperty('AltText', 'glyphicon glyphicon-ok')
  SELF.SetExtraProperty('btnStyle', 'success active')


Web:BtnClearSignature.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedAfterControl
    Target.Writeln('<<script>')
    Target.Writeln('$(function(){{')
    Target.Writeln('  $("#'&SELF.GetName()&'").click(function(e){{')
    Target.Writeln('        e.preventDefault();')
    Target.Writeln('$("#signature").jSignature("reset");')
    Target.Writeln('$("#LOC_SIGNATUREDATA").val($("#signature").jSignature("getData"));')
    Target.Writeln('    });')
    Target.Writeln('});')
    Target.Writeln('<</script>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


Web:BtnClearSignature.GetProperty PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0)

ReturnValue          &IValue

  CODE
  IF (name = 'ExtraClass')
    RETURN CreateStringValue('pull-right')
  END
  ReturnValue &= PARENT.GetProperty(name,idx1,idx2)
  RETURN ReturnValue


Web:BtnClearSignature.Init PROCEDURE(SIGNED Feq,SIGNED Container)

  CODE
  PARENT.Init(Feq,Container)
  SELF.SetExtraProperty('AltText', 'glyphicon glyphicon-erase')
  SELF.SetExtraProperty('btnStyle', 'danger')


WebWindowProperty.GetEmbedText PROCEDURE(ASTRING embed)

ReturnValue          ANY

Target                  &IHtmlWriter,AUTO
  CODE
  Target &= IHtmlWriter:Create()
  CASE embed
  OF A:EmbedJSAssets
    !See: http://willowsystems.github.io/jSignature/#/about/
    Target.Writeln('<<script type="text/javascript" src="../assets/js/jSignature.min.js"><</script>')    
  OF A:EmbedBeforeHeadClose
    Target.Writeln('')
    Target.Writeln('  <style type="text/css">')
      Target.Writeln('#GROUP1 {{')
      Target.Writeln('    border-style: none;')
      Target.Writeln('    box-shadow: unset;')
      Target.Writeln('}')
      Target.Writeln('#signatureparent {{')
      Target.Writeln('    padding-bottom: 15px;')
      Target.Writeln('}')
      Target.Writeln('#signature {{')
      Target.Writeln('    color: blue;')
      Target.Writeln('    background-color: white;')
      Target.Writeln('    border: 2px dotted black;')
      Target.Writeln('    margin-top: -15px;')
      Target.Writeln('    cursor: crosshair;')
      Target.Writeln('}')
      Target.Writeln('#LOC_SIGNATUREDATA_PROMPT {{')
      Target.Writeln('    margin-left: 15px;')
      Target.Writeln('}')
      Target.Writeln('#GROUP2 {{')
      Target.Writeln('    margin-top: 15px;')
      Target.Writeln('}')
      Target.Writeln('#GROUP2 .form-group {{')
      Target.Writeln('    position: relative;')
      Target.Writeln('    display: inline-block;')
      Target.Writeln('    font-weight: 400;')
      Target.Writeln('    vertical-align: middle;')
      Target.Writeln('    cursor: pointer;')
      Target.Writeln('    margin-left: 0px;')
      Target.Writeln('    margin-right: 15px;')
      Target.Writeln('    margin-bottom: 5px;')
      Target.Writeln('}')
      Target.Writeln('/* Color of main header */')
      Target.Writeln('.main-header {{')
      Target.Writeln('    color: #fff;')
      Target.Writeln('    background-color: #337ab7;')
      Target.Writeln('    text-align: center;')
      Target.Writeln('    display: block;')
      Target.Writeln('    margin-bottom: 5px;')
      Target.Writeln('}')
      Target.Writeln('/* Color of sub header */')
      Target.Writeln('.sub-header {{')
      Target.Writeln('    background-color: #d9edf7;')
      Target.Writeln('    text-align: center;')
      Target.Writeln('    display: block;')
      Target.Writeln('}')
    Target.WriteLn('  </style>')
  OF A:EmbedJavascriptOnBottom
    Target.Writeln('')
    Target.Writeln('<<script>')
    Target.Writeln('$(document).ready(function()')
    Target.Writeln('{{')
    !Touch devices (touchend event)
    Target.Writeln('$("#OK").on("touchend",function() {{')
    Target.Writeln('    $(this).attr("disabled", true);')
    Target.Writeln('    $("#BTNCLEARSIGNATURE").attr("disabled", true);')
    Target.Writeln('    $(".main-header").text("Please wait...");')
    Target.Writeln('});')
    !
    !Desktop with mouse (mouseup event, only when left mouse button)
    Target.Writeln('$("#OK").on("mouseup",function(e) {{')
    Target.Writeln('    if (e.which != 1) return false;') !If not left mouse button, then don't go any further...
    Target.Writeln('    $(this).attr("disabled", true);')
    Target.Writeln('    $("#BTNCLEARSIGNATURE").attr("disabled", true);')
    Target.Writeln('    $(".main-header").text("Please wait...");')
    Target.Writeln('});')
    !
    Target.Writeln('$("#LOC_SIGNATUREDATA").hide();')
    Target.Writeln('$("#signature").jSignature();')
    Target.Writeln('var datapair = $("#LOC_SIGNATUREDATA").val();')
    Target.Writeln('if (datapair) {{ $("#signature").jSignature("setData",datapair); }')
    Target.Writeln('$("#signature").bind(''change'', function(e){{ $("#LOC_SIGNATUREDATA").val($("#signature").jSignature("getData")); })')
    Target.Writeln('});')
    Target.Writeln('<</script>')
  END
  ReturnValue = PARENT.GetEmbedText(embed)
  ReturnValue = Target.GetText()
  Target.Release()
  RETURN ReturnValue


WebWindowProperty.GetProperty PROCEDURE(ASTRING name,unsigned idx1=0,unsigned idx2=0)

ReturnValue          &IValue

  CODE
  IF CLIP(LOC:SignatureData) <> '' !Important! ONLY use POST if the signature isn't empty, because else there will occur a timeout of 125 sec. when using POST
    IF (name = 'FormMethod')
      RETURN CreateStringValue('POST')
    ELSIF (name = 'FormEncoding')
      RETURN CreateStringValue('multipart/form-data')
    END
  END  
  IF (name = 'ExtraClass')
    RETURN CreateStringValue(' remove-side-margin-padding ')
  END
  IF (name = 'ExtraClassGP')
    RETURN CreateStringValue(' remove-side-padding ')
  END
  ReturnValue &= PARENT.GetProperty(name,idx1,idx2)
  RETURN ReturnValue


WebWindowProperty.GetSkeletonAttr PROCEDURE(SIGNED whichAttr)

ReturnValue          ANY

  CODE
  IF whichAttr = SkeletonAttr:RuntimeLayout
     RETURN 'off'
  END
  ReturnValue = PARENT.GetSkeletonAttr(whichAttr)
  CASE whichAttr
  END
  RETURN ReturnValue


WebWindowProperty.Init PROCEDURE

  CODE
  PARENT.Init
  SELF.SetTimeOut(600 - 60) !Set to keep the client app Alive


WebWindow.Init PROCEDURE

  CODE
  PARENT.Init
  WebWindowProperty.Init()
  WebWindowProperty.SetSubmitOnCancel(TRUE)
  SELF.AddControl(WebWindowProperty)
  Web:LOC:SignatureData:Prompt.Init(?LOC:SignatureData:Prompt, FEQ:Unknown)
  SELF.AddControl(Web:LOC:SignatureData:Prompt)
  Web:LOC:SignatureData.Init(?LOC:SignatureData, FEQ:Unknown)
  SELF.AddControl(Web:LOC:SignatureData)
  Web:Ok.Init(?Ok, FEQ:Unknown)
  SELF.AddControl(Web:Ok)
  Web:BtnClearSignature.Init(?BtnClearSignature, FEQ:Unknown)
  SELF.AddControl(Web:BtnClearSignature)


WebWindow.Kill PROCEDURE

  CODE
  WebWindowProperty.Kill()
  PARENT.Kill

